package MyBlog::Controller::Html;

use strict;
use warnings;
use base 'Catalyst::Controller';

=head1 NAME

MyBlog::Controller::Html - Catalyst Controller

=head1 DESCRIPTION

Catalyst Controller.

=head1 METHODS

=cut


=head2 index 

=cut

use Digest::MD5 qw(md5_hex);
sub index : Private {
    my($self, $c) = @_;

    # entries テーブルからエントリを取得する (更新日時の新しい順)
    my $rs = $c->model('DBIC::Entries')->search({}, { order_by => 'edited DESC' });

    # テンプレート用のデータ領域 ($c->stash) にエントリを追加する
    while (my $entry_resource = $rs->next) {
        my $entry   = XML::Atom::Entry->new(\$entry_resource->xml);
        my $content = $entry->content->body;
        utf8::encode $content;

        push @{ $c->stash->{entries} }, {
            link_hash => md5_hex($entry->link->href),
            title     => $entry->title,
            updated   => $entry->updated,
            content   => $content,
        };
    }
}

=head1 AUTHOR

Takeru INOUE

=head1 LICENSE

This library is free software, you can redistribute it and/or modify
it under the same terms as Perl itself.

=cut

1;
